Loading...
Searching...
No Matches
GoogleRestClient::GoogleCalendarRestConnection Class Reference

Class for Google REST connections; returns GoogleRestClient objects. More...

Inheritance diagram for GoogleRestClient::GoogleCalendarRestConnection:
[legend]

## Public Member Functions

| constructor (hash< auto > config, *hash< auto > attr)
| creates the GoogleRestConnection object
| constructor (string name, string description, string url=GoogleRestClient::DefaultUrl, hash< auto > attributes={}, hash< auto > options={})
| creates the GoogleRestConnection object
*string | getAppName ()
| Returns the data provider application name this connection serves, if any.
DataProvider::AbstractDataProvider | getDataProvider (*hash< auto > constructor_options)
| returns a data provider object for this connection
string | getType ()
| returns `"gcal"`
| setUpdateOptionsCode (*code update_options)
| Can be called to set or clear a closure or call reference to be called when options are automatically updated.
Public Member Functions inherited from GoogleRestClient::GoogleRestConnection
| constructor (hash< auto > config, *hash< auto > attr)
| creates the GoogleRestConnection object
| constructor (string name, string description, string url=GoogleRestClient::DefaultUrl, hash< auto > attributes={}, hash< auto > options={})
| creates the GoogleRestConnection object
string | getType ()
| returns `"grest"`

## Public Attributes

const | ConnectionScheme = ...
| Connection entry info.
const | DefaultConnectionUrl = "gcal://www.googleapis.com"
| Default Google REST API URL.
Public Attributes inherited from GoogleRestClient::GoogleRestConnection
const | ConnectionScheme = ...
| Connection entry info.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
Protected Member Functions inherited from GoogleRestClient::GoogleRestConnection
hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
GoogleRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a GoogleRestClient object
| setChildCapabilities ()
| Sets child data provider capabilities.

## Additional Inherited Members

Static Public Member Functions inherited from GoogleRestClient::GoogleRestConnection
static hash< auto > | getOptions (hash< auto > opts)
| returns options for GoogleRestConnection::constructor()

## Detailed Description

Class for Google REST connections; returns GoogleRestClient objects.

This class implements all options of GoogleRestConnection except `"api_profile"`, which is assumed to be `"calendar"`

See also
  GoogleRestClient::GoogleRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor() [1/2]

GoogleRestClient::GoogleCalendarRestConnection::constructor | ( | hash< auto > | config,
|  | *hash< auto > | attr )

creates the GoogleRestConnection object

Parameters

  config

  with the following keys:
  - name (required string): the connection name
  - display_name (optional string): the display name
  - short_desc (optional string): a short description in plain text
  - desc (optional string): a long description with markdown formatting
  - url (required string): the connection URL
  - opts (optional hash): connection options
  - logger (optional LoggerInterface object): logger for the connection

  attr

  optional connection attributes
  - monitor (optional bool): should the connection be monitored? Default: True
  - enabled (optional bool): is the connection enabled? Default: True
  - locked (optional bool): is the connection locked? Default: False
  - debug_data (optional bool): debug data? Default: False
  - tags (optional hash): tags for the connection; no default value

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option or attribute

## constructor() [2/2]

GoogleRestClient::GoogleCalendarRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url = GoogleRestClient::DefaultUrl,
|  | hash< auto > | attributes = {},
|  | hash< auto > | options = {} )

creates the GoogleRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | this aargument is ignored; the default Google API is always used
  attributes | various attributes. See below
  options | connection options

See ConnectionProvider::AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getAppName()

*string GoogleRestClient::GoogleCalendarRestConnection::getAppName | ( |  | ) |

Returns the data provider application name this connection serves, if any.

Returns
  the data provider application name this connection serves, if any

## getDataProvider()

DataProvider::AbstractDataProvider GoogleRestClient::GoogleCalendarRestConnection::getDataProvider | ( | *hash< auto > | constructor_options | ) |

returns a data provider object for this connection

Parameters

  constructor_options | any additional constructor options for the data provider

Returns
  a data provider object for this connection

## setUpdateOptionsCode()

GoogleRestClient::GoogleCalendarRestConnection::setUpdateOptionsCode | ( | *code | update_options | ) |

Can be called to set or clear a closure or call reference to be called when options are automatically updated.

The closure or call reference must have the following signature: `<update_options(hash<auto> options)`